parameters:
    mongo.session.options:
        database: session_db
        collection: session

services:
    mongo_client:
        class: MongoDB\Client
        # if using a username and password
        # arguments: ['mongodb://%mongodb_username%:%mongodb_password%@%mongodb_host%:27017']
        arguments: ['%env(resolve:MONGO_URL)%']
    session.handler.mongo:
        class: Symfony\Component\HttpFoundation\Session\Storage\Handler\MongoDbSessionHandler
        arguments: ['@mongo_client', '%mongo.session.options%']

    ovski.console.command.import_translations:
        class: App\Command\ImportTranslationsCommand
        tags:
            - { name: console.command }

    ovski.translation_manager:
        class: 'App\Service\TranslationManager'
        arguments: ['@doctrine.orm.entity_manager']

    # validators
    ovski.translation_requires_articles_validator:
        class: 'App\Validator\Constraints\TranslationRequiresArticlesValidator'
        arguments: ['@doctrine.orm.entity_manager']
        tags:
            - { name: validator.constraint_validator, alias: translation_requires_articles_validator }
    ovski.translation_unique_validator:
        class: 'App\Validator\Constraints\TranslationUniqueValidator'
        arguments: ['@doctrine.orm.entity_manager', '@security.token_storage']
        tags:
            - { name: validator.constraint_validator, alias: translation_unique_validator }
    ovski.learning_unique_validator:
        class: 'App\Validator\Constraints\LearningUniqueValidator'
        arguments: ['@doctrine.orm.entity_manager', '@security.token_storage']
        tags:
            - { name: validator.constraint_validator, alias: learning_unique_validator }
    ovski.learning_languages_not_identical_validator:
        class: 'App\Validator\Constraints\LearningLanguagesNotIdenticalValidator'
        arguments: ['@doctrine.orm.entity_manager']
        tags:
            - { name: validator.constraint_validator, alias: learning_languages_not_identical_validator }
    ovski.translation_words_not_blank_validator:
        class: 'App\Validator\Constraints\TranslationWordsNotBlankValidator'
        tags:
            - { name: validator.constraint_validator, alias: translation_words_not_blank_validator }

    # fixtures
    ovski.fixtures.load_learning_data:
        class: 'App\DataFixtures\ORM\Dev\LoadLearningData'
        tags:
            - { name: doctrine.fixture.orm }
    ovski.fixtures.load_translation_data:
        class: 'App\DataFixtures\ORM\Dev\LoadTranslationData'
        tags:
            - { name: doctrine.fixture.orm }
    ovski.fixtures.load_word_data:
        class: 'App\DataFixtures\ORM\Dev\LoadWordData'
        tags:
            - { name: doctrine.fixture.orm }
    ovski.fixtures.load_article_data:
        class: 'App\DataFixtures\ORM\Prod\LoadArticleData'
        tags:
            - { name: doctrine.fixture.orm }
    ovski.fixtures.load_language_data:
        class: 'App\DataFixtures\ORM\Prod\LoadLanguageData'
        tags:
            - { name: doctrine.fixture.orm }
    ovski.fixtures.load_word_type_data:
        class: 'App\DataFixtures\ORM\Prod\LoadWordTypeData'
        tags:
            - { name: doctrine.fixture.orm }
    ovski.fixtures.load_user_data:
        class: 'App\DataFixtures\ORM\Dev\LoadUserData'
        arguments: ['@security.encoder_factory']
        tags:
            - { name: doctrine.fixture.orm }
